﻿init python:
    import pygame
    class player_unit(actor, equip, inventory_class):
        def __init__(self, name, x, y, level = 1, portrait = "no_portrait"):
            actor.__init__(self, name, x, y, level, portrait)
            equip.__init__(self)
            inventory_class.__init__(self, cash = 0, items = [bronze_chestplate], markup = 1.0, bags = [[42, "Backpack"], [4, "Pockets"]])

    def create_animations(name, type = "enemy"):
        img = "rpg/{}/{}/sheet.png".format(type, name)
        
        n = "{} down idle".format(name)
        d = Crop((32, 0, 32, 32), img)
        # d = DynamicDisplayable(show_countdown)
        renpy.image(n, d)

        n = "{} up idle".format(name)
        d = Crop((32, 96, 32, 32), img)
        renpy.image(n, d)
        
        n = "{} left idle".format(name)
        d = Crop((32, 32, 32, 32), img)
        renpy.image(n, d)

        n = "{} right idle".format(name)
        d = Crop((32, 64, 32, 32), img)
        renpy.image(n, d)

        n = "{} down walk".format(name)
        d = Animation([
            Crop((0, 0, 32, 32), img),
            Crop((32, 0, 32, 32), img),
            Crop((64, 0, 32, 32), img),
            Crop((32, 0, 32, 32), img)
            ], .1)
        renpy.image(n, d)

        n = "{} up walk".format(name)
        d = Animation([
            Crop((0, 96, 32, 32), img),
            Crop((32, 96, 32, 32), img),
            Crop((64, 96, 32, 32), img),
            Crop((32, 96, 32, 32), img)
            ], .1)
        renpy.image(n, d)

        n = "{} left walk".format(name)
        d = Animation([
            Crop((0, 32, 32, 32), img),
            Crop((32, 32, 32, 32), img),
            Crop((64, 32, 32, 32), img),
            Crop((32, 32, 32, 32), img)
            ], .1)
        renpy.image(n, d)

        n = "{} right walk".format(name)
        d = Animation([
            Crop((0, 64, 32, 32), img),
            Crop((32, 64, 32, 32), img),
            Crop((64, 64, 32, 32), img),
            Crop((32, 64, 32, 32), img)
            ], .1)
        renpy.image(n, d)

        n = "{}  dead".format(name)
        d = Crop((16, 16, 16, 32), img)
        renpy.image(n, d)
        return img
    
init python: # credits to hell_oh_world and Alex on lemmasoft for helping me figure out this part
    def animation(st, at, frames=[], interval=None):
        frame_count = len(frames)
        if interval is None:
            interval = 1 / float(frame_count)
        return frames[int((st // interval) % frame_count)], interval

    def Animation(frames, interval=0.08):
        return DynamicDisplayable(animation, frames=frames, interval=interval)


#---------------------------------------- Hero
define you_sheet = create_animations("You", "npc")
default hiro = Character("You")
default player = player_unit(
    "You",
    0,0,
    renpy.random.randint(1,4),
    "player_portrait"
)
default hero = player
default nobody = player_unit(
    "",
    0,0,

)
python:
    nobody.heath = hp
default talking_to = nobody
#---------------------------------------- NPC
define laria_sheet = create_animations("Laria", "npc")
default laria = player_unit(
    "Laria",
    0,0,
    2,
    "laria_portrait"
)


define thora_sheet = create_animations("Thora", "npc")
default thora = player_unit(
    "Thora",
    0,0,
    5,
    "thora_portrait"
)



#---------------------------------------- Enemy
define demon_sheet = create_animations("Demon")
default demon = player_unit(
    "Demon",
    0,0,
)
#---------------------------------------- Levels

default larias_room = level_class(
    _("Small room"),
    32,
    ["labyrinth ground", "rpg/levels/larias_room.csv"],
    [[12,8,spiked_stick]],
    player = player,
    entrances = [[15,4]],
    exits = [[15, 3, "the_well", 1]],
    npc = [
        [laria, 14, 8],
    ]
)
default the_well = level_class(
    _("The well"),
    32,
    ["labyrinth ground", "rpg/levels/the_well.csv"],
    [[4,5,spiked_stick], [6,5,spiked_stick], [4,7,engraved_chestplate], [4,6,wavy_dagger]],
    player = player,
    entrances = [[3,1], [24,8]],
    exits = [[3, 0, "level_2", 0], [24, 9, "larias_room", 0]],
    npc = [
        [thora, 4, 4],
    ]
)
default level_2 = level_class(
    _("Level 2"),
    32,
    ["labyrinth ground", "rpg/levels/level_2.csv"],
    None,
    player = player,
    entrances = [[2,6], [25,2]],
    exits = [[2, 7, "the_well", 0], [25, 1, "level_3", 0]]
)
default level_3 = level_class(
    _("Level 3"),
    32,
    ["labyrinth ground", "rpg/levels/level_3.csv"],
    None,
    player = player,
    entrances = [[3,9], [25,2]],
    exits = [[3, 10, "level_2", 1], [25, 1, "level_3", 0]]
)

label level_1:
    $ the_well.enter(0)
    show screen level(the_well)
    pause 1
    "Yep"
    "I'm lost!"
    window hide
label game_loop:
    pause
    jump game_loop










